# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from ... import _utilities, _tables
from . import outputs

__all__ = [
    'GetPostgresInstanceResult',
    'AwaitableGetPostgresInstanceResult',
    'get_postgres_instance',
]

@pulumi.output_type
class GetPostgresInstanceResult:
    """
    A Postgres Instance.
    """
    def __init__(__self__, hybrid_data_manager_id=None, location=None, name=None, system_data=None, tags=None, type=None):
        if hybrid_data_manager_id and not isinstance(hybrid_data_manager_id, str):
            raise TypeError("Expected argument 'hybrid_data_manager_id' to be a str")
        pulumi.set(__self__, "hybrid_data_manager_id", hybrid_data_manager_id)
        if location and not isinstance(location, str):
            raise TypeError("Expected argument 'location' to be a str")
        pulumi.set(__self__, "location", location)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if system_data and not isinstance(system_data, dict):
            raise TypeError("Expected argument 'system_data' to be a dict")
        pulumi.set(__self__, "system_data", system_data)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="hybridDataManagerId")
    def hybrid_data_manager_id(self) -> Optional[str]:
        """
        null
        """
        return pulumi.get(self, "hybrid_data_manager_id")

    @property
    @pulumi.getter
    def location(self) -> str:
        """
        The geo-location where the resource lives
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="systemData")
    def system_data(self) -> 'outputs.SystemDataResponse':
        """
        Read only system data
        """
        return pulumi.get(self, "system_data")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Mapping[str, str]]:
        """
        Resource tags.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The type of the resource. Ex- Microsoft.Compute/virtualMachines or Microsoft.Storage/storageAccounts.
        """
        return pulumi.get(self, "type")


class AwaitableGetPostgresInstanceResult(GetPostgresInstanceResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPostgresInstanceResult(
            hybrid_data_manager_id=self.hybrid_data_manager_id,
            location=self.location,
            name=self.name,
            system_data=self.system_data,
            tags=self.tags,
            type=self.type)


def get_postgres_instance(postgres_instance_name: Optional[str] = None,
                          resource_group_name: Optional[str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPostgresInstanceResult:
    """
    Use this data source to access information about an existing resource.

    :param str postgres_instance_name: Name of Postgres Instance
    :param str resource_group_name: The name of the Azure resource group
    """
    __args__ = dict()
    __args__['postgresInstanceName'] = postgres_instance_name
    __args__['resourceGroupName'] = resource_group_name
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
    __ret__ = pulumi.runtime.invoke('azure-nextgen:azuredata/v20190724preview:getPostgresInstance', __args__, opts=opts, typ=GetPostgresInstanceResult).value

    return AwaitableGetPostgresInstanceResult(
        hybrid_data_manager_id=__ret__.hybrid_data_manager_id,
        location=__ret__.location,
        name=__ret__.name,
        system_data=__ret__.system_data,
        tags=__ret__.tags,
        type=__ret__.type)
